------------------------------------------------------------------------------
--                                                                          --
--                        XVIEW ADA LIBRARY COMPONENTS                      --
--                                                                          --
--                          XV_SERVER_IMAGE_PACKAGE                         --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--          Copyright (c) 1995 Andreas Almroth, All Rights Reserved         --
--                                                                          --
-- The  XVIEW ADA  library is free software; you can redistribute it and/or --
-- modify  it  under terms of the  GNU  Library General  Public  License as --
-- published by the Free Software Foundation; either version 2, or (at your --
-- option) any later version. The XVIEW ADA library is  distributed  in the --
-- hope that it will be useful,  but WITHOUT ANY WARRANTY; without even the --
-- implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. --
-- See the GNU Library General Public License for more details.             --
-- You should have  received  a  copy of the  GNU  Library  General  Public --
-- License along with the XVIEW ADA library; see the file  COPYING.LIB.  If --
-- not, write to the Free  Software  Foundation, 675  Mass  Ave, Cambridge, --
-- MA 02139, USA.                                                           --
--                                                                          --
------------------------------------------------------------------------------

with Xv_Base_Package,Interfaces.C;
use  Xv_Base_Package;
with Ada.Finalization;
use  Ada.Finalization;

package Xv_Server_Image_Package is
   type Server_Image is new Xv_Opaque;
   type Image_Data is array (Integer range 1..512) of Interfaces.C.Unsigned_Char;
--   type Image_Data is array (Integer range <>) of Interfaces.C.Unsigned_Char;
   type Image_Data_Ptr is access all Image_Data;

   type Xv_Server_Image (Image : Image_Data_Ptr; W,H : Integer) 
   is new Controlled with private;
   type Xv_Server_Image_Ptr is access all Xv_Server_Image;


   procedure Initialize (V : in out Xv_Server_Image);
   procedure Finalize (V : in out Xv_Server_Image);
   function Get_Server_Image (V : in Xv_Server_Image) return Server_Image;

private
   type Xv_Server_Image (Image : Image_Data_Ptr; W,H : Integer)
   is new Controlled with
      record
	 Base      : Server_Image;
	 The_Image : Image_Data_Ptr := Image;
	 Width     : Integer := W;
	 Height    : Integer := H;
      end record;
end Xv_Server_Image_Package;
